#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

int perm[24][5] = {
     {0, 1, 2, 3, 0}, {0, 1, 3, 2, 1}, {0, 2, 1, 3, 1}, {0, 2, 3, 1, 0}, {0, 3, 1, 2, 0}, {0, 3, 2, 1, 1},
     {1, 0, 2, 3, 1}, {1, 0, 3, 2, 0}, {1, 2, 0, 3, 0}, {1, 2, 3, 0, 1}, {1, 3, 0, 2, 1}, {1, 3, 2, 0, 0},
     {2, 0, 1, 3, 0}, {2, 0, 3, 1, 1}, {2, 1, 0, 3, 1}, {2, 1, 3, 0, 0}, {2, 3, 0, 1, 0}, {2, 3, 1, 0, 1},
     {3, 0, 1, 2, 1}, {3, 0, 2, 1, 0}, {3, 1, 0, 2, 0}, {3, 1, 2, 0, 1}, {3, 2, 0, 1, 1}, {3, 2, 1, 0, 0}};

int sz, fld[201][201], hlp[101][101];

vector <int> ans;

inline void rot(int k) {
    if(k > 0) for(int i = 1; i <= sz; i++) swap(fld[k][i], fld[k][2 * sz + 1 - i]);
    if(k < 0) for(int i = 1; i <= sz; i++) swap(fld[i][-k], fld[2 * sz + 1 - i][-k]);
    ans.push_back(k);
}

bool buildhlp() {
    int bn[4] = {fld[1][1], fld[2 * sz][1], fld[1][2 * sz], fld[2 * sz][2 * sz]};
    for(int i = 1; i <= sz; i++) {
        for(int j = 1; j <= sz; j++) {
            int kn[4] = {fld[i][j], fld[2 * sz + 1 - i][j], fld[i][2 * sz + 1 - j], fld[2 * sz + 1 - i][2 * sz + 1 - j]};
            int t = -1;
            for(int k = 0; k < 24; k++) {
                if(bn[0] == kn[perm[k][0]] && bn[1] == kn[perm[k][1]] &&
                    bn[2] == kn[perm[k][2]] && bn[3] == kn[perm[k][3]]) {
                        if(t == -1) t = perm[k][4];
                        else t = 0;
                }
            }

            hlp[i][j] = t;
            if(t == -1) return false;
        }
    }
    return true;
}

void solve() {
    if(!buildhlp()) return;
    for(int i = 1; i <= sz; i++)
        if(hlp[i][1] == 1) rot(i);

    buildhlp();

    for(int i = 1; i <= sz; i++) {
        int sum = 0;
        for(int j = 1; j <= sz; j++) sum += hlp[j][i];
        if(sum == sz) {sum = 0; rot(-i);}
        if(sum != 0) {ans.clear(); return;}
    }

    int bn[4] = {fld[1][1], fld[2 * sz][1], fld[1][2 * sz], fld[2 * sz][2 * sz]};
    for(int i = 1; i <= sz; i++) {
        for(int j = 1; j <= sz; j++) {
            if(fld[i][2 * sz + 1 - j] == bn[0]) {
                rot(i); rot(-j);
                rot(i); rot(-j);
            } else if(fld[2 * sz + 1 - i][j] == bn[0]) {
                rot(-j); rot(i);
                rot(-j); rot(i);
            } else if(fld[2 * sz + 1 - i][2 * sz + 1 - j] == bn[0]) {
                rot(i); rot(-(2 * sz + 1 - j));
                rot(i); rot(-(2 * sz + 1 - j));
            } else if(fld[2 * sz + 1 - i][j] == bn[2]) {
                rot(-(2 * sz + 1 - j)); rot(2 * sz + 1 - i);
                rot(-(2 * sz + 1 - j)); rot(2 * sz + 1 - i);
            } else if(fld[2 * sz + 1 - i][2 * sz + 1 - j] == bn[2]) {
                rot(2 * sz + 1 - i); rot(-(2 * sz + 1 - j));
                rot(2 * sz + 1 - i); rot(-(2 * sz + 1 - j));
            }
        }
    }

    bn[0] = fld[1][1]; bn[1] = fld[2 * sz][1]; bn [2] = fld[1][2 * sz]; bn[3] = fld[2 * sz][2 * sz];

    for(int i = 1; i <= sz; i++) {
        for(int j = 1; j <= sz; j++) {
            if(fld[2 * sz + 1 - i][j] == bn[3]) {
                if(bn[0] == bn[2]){
                    rot(-j); rot(2 * sz + 1 - i);
                    rot(-j); rot(2 * sz + 1 - i);
                    rot(i); rot(-j);
                    rot(i); rot(-j);

                } else if(bn[0] == bn[3]){
                    rot(2 * sz + 1 - i); rot(-j);
                    rot(2 * sz + 1 - i); rot(-j);
                } else if(bn[2] == bn[1]){
                    rot(2 * sz + 1 - i); rot(-(2 * sz + 1 - j));
                    rot(2 * sz + 1 - i); rot(-(2 * sz + 1 - j));
                } else if(bn[2] == bn[3]){
                    rot(-(2 * sz + 1 - j)); rot(2 * sz + 1 - i);
                    rot(-(2 * sz + 1 - j)); rot(2 * sz + 1 - i);
                }
            }
        }
    }
    ans.insert(ans.begin(), ans.size());
}

int main() {
    freopen("square.in", "r", stdin);
    freopen("square.out", "w",stdout);

    int t;
    cin >> t;
    for(int k = 0; k < t; k++) {
        cin >> sz;
        for(int i = 1; i <= 2 * sz; i++)
            for(int j = 1; j <= 2 * sz; j++)
                cin >> fld[i][j];
        solve();
        if(!ans.size()) cout << "-1\n";
        else {
            cout << ans[0] << '\n';
            for(int i = 1; i < ans.size(); i++)
                printf("%+d\n", ans[i]);
        }
        ans.clear();
    }
}
