/* GCC */

#include <fstream>
#include <cstdio>
#include <vector>
#include <stdint.h>
#include <cmath>
#include <cstring>
using namespace std;

typedef int64_t i64;

const int Nmax = 260000;
const int Inf = 2e9;

int x[Nmax], y[Nmax], Left[Nmax], Right[Nmax];


i64 dist(int u, int v)
{
    if (u == -1 || v == -1)
        return 0;
    return abs(x[u]-x[v]) + abs(y[u]-y[v]);
}

int main()
{
    freopen("nests.in", "r", stdin);

    int n;
    scanf("%d", &n);

    for (int i=1;i<=n; ++i) {
        scanf("%d%d", &x[i], &y[i]);
    }

    memset(Left, -1, 4*Nmax);
    memset(Right, -1, 4*Nmax);

    y[0] = Inf;
    vector<int> s;
    s.push_back(0);

    for (int i=1;i<=n;++i) {
        while (y[s.back()] < y[i]) {
            Left[i] = s.back();
            s.pop_back();
        }
        Right[s.back()] = i;
        s.push_back(i);
    }

    i64 ans = 0;

    for (int i=1;i<=n; ++i) {
        ans += dist(i, Left[i]) + dist(i, Right[i]);
    }

    ofstream fout("nests.out");
    fout << ans << "\n";



    return 0;
}
